class BTreeNode
  attr_reader :addresses,:keys,:values,:size,:disk
  attr_writer :leaf,:keys,:values,:addresses
  def initialize(size,disk)
    @disk=disk
    @size=size #the max size of keys, values
    @keys=Array.new #array with keys
    @values=Array.new #array with values
    @addresses=Array.new #addresses on disk
    @addresses[0]=0
    @leaf =true #is this node a leaf or an internal node?
  end
  
  def leaf?
    @leaf
  end  
  
  #splits this node, returns a new node with the second half and the keys[median] and values[median] element
  #the address, keys and values of 
  def split(key,value,address)
    raise "the node is not full" if !full?
    
    add(key,value,address)
    
    new_node=BTreeNode.new(size,disk)
    new_node.leaf=leaf?
    
		median= size/2+1; #size is odd!!
    median_key=keys[median]
    median_value=values[median]
     
    new_node.keys=keys[median+1,median-1]
    new_node.values=values[median+1,median-1]
    new_node.addresses=addresses[median+1,median]
    new_node.addresses[-1]=address  unless (median_key >= key)
    
    #puts "split #{key} #{value} #{address} #{median_key}"
    
    @keys=keys[0,median]
    @values=values[0,median]
    @addresses=addresses[0,median+1]
    
    return [new_node,median_key,median_value]
  end
  
  #returns the te place of the key in keys and true if the key is found
  def search(key)		
    i = 0
		i += 1 while(i<keys.size and key>keys[i]) 
    return [i,(i!=size and keys[i]==key)]
  end
  
  def each    
    yield self
    addresses.each{ |address| disk.read(address).each{|node| yield node}} unless leaf?
  end
  
  def add(key,value,address)
    place,found=search(key)
    #raise "invalid status: key already in node" if found
    keys.insert(place,key)
    values.insert(place,value)
    addresses.insert(place+1,address)
  end
  
  def set_value(key,value)
    place,found=search(key)
    #raise "key not found" unless found
    values[place]=value
  end
  
  def full?
    #raise "key size != value size" if keys.size != values.size
    #raise "addresses size not correct" if keys.size + 1 != addresses.size
    size==keys.size
  end
  
  def to_s
    string =""
    string += "load: #{keys.size}, leaf? #{leaf?}\n"
    string += "\tkeys:\t" + keys.join(" | ")+"\n"
    string += "\tvalues:\t" + values.join(" | ")+"\n"
    string += "\taddrs:\t" + addresses.join(" | ")+"\n"
    string
  end
end
