
#mixin for redblack tree that implemnts add and delete bottom up
module BottomUp
  #adds a new node bottom-up
  #duplicate key values not allowed, []= checks if the key is used
  def add(key,data)
    array = find_place(key)
    place = array[0]
    parent= array[1]
    place.root = RedBlackNode.new(key,data,Color::RED,parent)    
    child = place.root
    
    #first case: new node is red, parent red, uncle red, grandparent black
    while(!parent.nil? and parent.red? and parent.parent.right.red? and parent.parent.left.red?)  do
      #parent=red so there is a black grand parent
      #so colors have to be switched
      # het probleem verder opschuiven naar boven
      # er kunnen zich nu problemen voordoen tussen de grootouder en de overgrootouder
      # die beide rood kunnen zijn
      parent.parent.right.root.color = Color::BLACK
      parent.parent.left.root.color = Color::BLACK
      parent.parent.color = Color::RED		
      child=parent.parent
      parent=child.parent
      
      #puts "solved first case"
    end
    
    #problem solved or to solvable with local rotations
    #case 3: uncle is black, grandparent is black, parent and child not on same side => rotate to case 2
    if(!parent.nil? and parent.red? and !on_same_side_as_parent(child)) then
      #puts "solving third case"
      if(!parent.right.root.nil? and parent.right.root.key==child.key) then
        find_tree(parent).rotate(Direction::LEFT)
      else
        find_tree(parent).rotate(Direction::RIGHT)
      end
      child=parent
      parent=child.parent      
    end
    
    #case 2: black uncle, black grandparent, child and parent on same side
    if(!parent.nil? and parent.red? and on_same_side_as_parent(child)) then
      #puts "solving second case"
      parent.color=Color::BLACK
      parent.parent.color=Color::RED
      if(!parent.left.root.nil? and parent.left.root.key==child.key) then
        find_tree(parent.parent).rotate(Direction::RIGHT)
      else
        find_tree(parent.parent).rotate(Direction::LEFT)
      end
    end
    
    root.color=Color::BLACK
  end
  
   #removes the node with specified key
  #does nothing when key is not found
  def delete(key)
    array= find_place(key)
    place = array[0]
    parent = array[1]
    to_delete = place.root
    
    return if place.root.nil?
    
    color_to_delete = to_delete.color
    if(to_delete.left.root.nil?) then
      place.root=to_delete.right.root
      place.root.parent = parent unless(place.root.nil?)
      #to_delete.right.root = nil
    elsif (to_delete.right.root.nil?) then
      place.root = to_delete.left.root
      place.root.parent=parent unless(place.root.nil?)
      #to_delete.left.root=nil
    else #replace by predecessor
      predecessor_tree = predecessor(to_delete)
      predecessor_node = predecessor_tree.root
      color_to_delete = predecessor_node.color
      predecessor_node.color=to_delete.color
      if(to_delete.left == predecessor_tree) # predecessor is left child
        
      else # predecessor no left child
        place = predecessor_tree
        predecessor_tree.root = predecessor_node.left.root
        predecessor_node.left.root.parent = predecessor_node.parent unless (predecessor_node.left.root.nil?)
        #the next two have to exist!
      end
      
      #to_delete.left.root=nil
      #to_delete.right.root=nil
    end
    check
  end
end