require 'BTree/BTree.rb'
require 'RedBlackTree/RedBlackTree.rb'

start = Time.new
text=String.new
tree = BTree.new(17)
rbtree=RedBlackTree.new()

File.open("bible.txt"){ |bible|  text = bible.read }
words = text.split(/[^a-zA-Z]/)
old_percent=0
words.each_index do |i|
  word=words[i].strip.downcase
  next if word.empty?
  count = tree[word]
  if(count) then
    tree[word]=count + 1
  else
    tree[word]=1
  end  
  new_percent = ((i+1.to_f)/words.size.to_f * 100.0).to_i
  puts "#{new_percent}% done" if (old_percent!=new_percent and new_percent%10==0)
  old_percent=new_percent
end


tree.each do |node|
  node.keys.each_index{|i| rbtree[node.values[i]]=node.keys[i]}
end

max=10
count=1
rbtree.each_biggest_first do |node|
  puts "#{node.data}\t#{node.key}"
  count+=1
  break if (count > max)
end

stop = Time.new
span=stop-start
puts "Finished in #{span} seconds"
